<script setup lang="ts">
import { genres } from '@/utils/consts'
import { type Ref, ref } from 'vue'
import { useMoviesStore } from '@/stores/movies'
import type { MoviesParams } from '@/utils/types'

const search: Ref<string | null> = ref(null)
const selected: Ref<[] | null> = ref(null)
const searchTimeout: Ref<any> = ref(null)

const moviesStore = useMoviesStore()

const onTriggerSearchFilter = async (): Promise<void> => {
  if (searchTimeout.value) {
    clearTimeout(searchTimeout.value)
  }

  searchTimeout.value = setTimeout(async () => {
    await makeRequest()
  }, 400)
}

const onTriggerGenreFilter = async (): Promise<void> => {
  await makeRequest()
}

const makeRequest = async (): Promise<void> => {
  moviesStore.loading = true

  const params: MoviesParams = {}

  if (search.value && search.value !== '') {
    params.name = search.value
  }

  if (selected.value && selected.value.length > 0) {
    params.genres = selected.value
  }

  await moviesStore.getMovies(params)

  moviesStore.loading = false
}
</script>

<template>
  <v-container>
    <v-row>
      <v-col cols="12" lg="9">
        <v-text-field v-model="search"
                      placeholder="Search"
                      append-inner-icon="mdi-magnify"
                      single-line
                      clearable
                      hide-details
                      @update:modelValue="onTriggerSearchFilter"
        />
      </v-col>

      <v-col cols="12" lg="3">
        <v-select v-model="selected"
                  :items="genres"
                  placeholder="Genre"
                  item-text="title"
                  item-value="id"
                  hide-details
                  multiple
                  clearable
                  @update:modelValue="onTriggerGenreFilter"
        >
          <template v-slot:selection="{ item, index }">
            <v-chip v-if="selected && index === 0">
              <span>{{ item.title }}</span>
            </v-chip>
            <span v-if="selected && index === 1" class="grey--text text-caption">
              (+{{ selected.length - 1 }} others)
            </span>
          </template>
        </v-select>
      </v-col>
    </v-row>
  </v-container>
</template>
